require 'tk'

#===============================================================================
#
#	Class: LegacyGraphics
#
class LegacyGraphics

	@@color = Array['black', 'blue', 'red', 'magenta', 'green', 'cyan', 'yellow', 'white']

	def initialize(h_dmy, w_dmy, y_dmy, x_dmy, gy = 400, gx = 640, cy = 16, cx = 8)
		@lx = 0
		@ly = 0

		@root = TkRoot.new {
			title('TrueLegacyGraphics')
		}

		@canvas = TkCanvas.new {
			width(gx)
			height(gy)
		}.pack

		fill(0, 0, gx - 1, gy - 1, 0)
	end

	def pset(x, y, c)

		fill(x, y, x, y, c)
	end

	def locate(x, y)
	end

	def print(mes)
	end

	def line(x1, y1, x2, y2, c)
		@lx = x2
		@ly = y2
		_line(x1, y1, x2, y2, c)
	end

	def cline(x, y, c)
			  x1 = @lx
			  y1 = @ly
		@lx = x2 = x
		@ly = y2 = y
		_line(x1, y1, x2, y2, c)
	end

	#---------------------------------------------------------------------------
	#
	#	_line
	#
	def _line(x1, y1, x2, y2, c)

		TkcLine.new(@canvas, x1 + 1, y1 + 1, x2 + 1, y2 + 1) {
			width(1)
			fill(@@color[c.class <= Numeric ? c : 7])
		}
		pset(x2, y2, c)
	end

	def circle(x, y, r, c)
		# not implement yet
	end

	def fill(x1, y1, x2, y2, c)

		TkcRectangle.new(@canvas, x1 + 1, y1 + 1, x2 + 2, y2 + 2) {
			width(0)
			fill(@@color[c.class <= Numeric ? c : 7])
		}
	end

	def clear
	end

	def box(vchar_dmy, hchar_dmy)
	end

	def refresh
		Tk.mainloop
	end

	def close
	end
end
